unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, DBGrids, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ColorBox, ExtCtrls, rxdbgrid, rxmemds, math;

type

  { TForm1 }

  TForm1 = class(TForm)
    cbbSelectColor: TColorBox;
    cbbSelectFontColor: TColorBox;
    DataSource1: TDataSource;
    DBGrid: TRxDBGrid;
    GroupBox1: TGroupBox;
    lblSelectColor: TLabel;
    lblSelectFontColor: TLabel;
    MD: TRxMemoryData;
    MDcurr: TFloatField;
    MDstr1: TStringField;
    MDstr2: TStringField;
    RadioGroup1: TRadioGroup;
    procedure cbbSelectColorChange(Sender: TObject);
    procedure cbbSelectFontColorChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MDcurrGetText(Sender: TField; var aText: string;
      DisplayText: Boolean);
    procedure RadioGroup1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
begin
  MD.Active:= True;

  for i:= 0 to 10 do
    MD.AppendRecord(['fld ' + IntToStr(i), 'fld ' + IntToStr(i*2), RandomRange(1,1000000) + Random]);

  cbbSelectColor.Selected:= clHighlight;
  cbbSelectFontColor.Selected:= clHighlightText;
  RadioGroup1Click(Sender);
end;

procedure TForm1.cbbSelectColorChange(Sender: TObject);
begin
  DBGrid.SelectedColor:= cbbSelectColor.Selected;
  DBGrid.Invalidate;
end;

procedure TForm1.cbbSelectFontColorChange(Sender: TObject);
begin
  DBGrid.SelectedFontColor:= cbbSelectFontColor.Selected;
  DBGrid.Invalidate;
end;

procedure TForm1.MDcurrGetText(Sender: TField; var aText: string;
  DisplayText: Boolean);
begin
  Application.UpdateFormatSettings:= False;

  if Sender.DataSet.RecNo mod 2 > 0
    then
      begin
        CurrencyFormat:= 2;
        ThousandSeparator:= ',';
        DecimalSeparator:= '.';
        CurrencyString:= '$';
      end
    else
      begin
        ThousandSeparator:= ' ';
        DecimalSeparator:= ',';
        CurrencyFormat:= 3;
        CurrencyString:= 'руб';
      end;

  aText:= FloatToStrF(Sender.AsFloat,ffCurrency,10,2);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
    0: DBGrid.Options:= DBGrid.Options - [dgRowHighlight, dgRowSelect];
    1: DBGrid.Options:= DBGrid.Options + [dgRowHighlight] - [dgRowSelect];
    2: DBGrid.Options:= DBGrid.Options - [dgRowHighlight] + [dgRowSelect];
  end;

  DBGrid.Invalidate;
end;

end.

